Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.servlet.http
Interface HttpServletRequest

All Superinterfaces:
  ServletRequest

All Known Implementing Classes:
  HttpServletRequestWrapper

public interface HttpServletRequest
extends ServletRequest

Extends the `ServletRequest` interface to provide request information for HTTP servlets.

The servlet container creates an `HttpServletRequest` object and passes it as an argument to the servlet's service methods (`doGet`, `doPost`, etc).

Version:
  $Version$
Author:
  Various

Field Summary
`static java.lang.String` | `BASIC_AUTH` String identifier for Basic authentication.
`static java.lang.String` | `CLIENT_CERT_AUTH` String identifier for Basic authentication.
`static java.lang.String` | `DIGEST_AUTH` String identifier for Basic authentication.
`static java.lang.String` | `FORM_AUTH` String identifier for Basic authentication.

Method Summary
`java.lang.String` | `getAuthType()` Returns the name of the authentication scheme used to protect the servlet.
`java.lang.String` | `getContextPath()` Returns the portion of the request URI that indicates the context of the request.
`Cookie[]` | `getCookies()` Returns an array containing all of the `Cookie` objects the client sent with this request.
`long` | `getDateHeader(java.lang.String name)` Returns the value of the specified request header as a `long` value that represents a `Date` object.
`java.lang.String` | `getHeader(java.lang.String name)` Returns the value of the specified request header as a `String`.
`java.util.Enumeration` | `getHeaderNames()` Returns an enumeration of all the header names this request contains.
`java.util.Enumeration` | `getHeaders(java.lang.String name)` Returns all the values of the specified request header as an `Enumeration` of `String` objects.
`int` | `getIntHeader(java.lang.String name)` Returns the value of the specified request header as an `int`.
`java.lang.String` | `getMethod()` Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`java.lang.String` | `getPathInfo()` Returns any extra path information associated with the URL the client sent when it made this request.
`java.lang.String` | `getPathTranslated()` Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`java.lang.String` | `getQueryString()` Returns the query string that is contained in the request URL after the path.
`java.lang.String` | `getRemoteUser()` Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated.
`java.lang.String` | `getRequestedSessionId()` Returns the session ID specified by the client.
`java.lang.String` | `getRequestURI()` Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`java.lang.StringBuffer` | `getRequestURL()` Reconstructs the URL the client used to make the request.
`java.lang.String` | `getServletPath()` Returns the part of this request's URL that calls the servlet.
`HttpSession` | `getSession()` Returns the current session associated with this request, or if the request does not have a session, creates one.
`HttpSession` | `getSession(boolean create)` Returns the current `HttpSession` associated with this request or, if if there is no current session and `create` is true, returns a new session.
`java.security.Principal` | `getUserPrincipal()` Returns a `java.security.Principal` object containing the name of the current authenticated user.
`boolean` | `isRequestedSessionIdFromCookie()` Checks whether the requested session ID came in as a cookie.
`boolean` | `isRequestedSessionIdFromUrl()` Deprecated. As of Version 2.1 of the Java Servlet API, use `isRequestedSessionIdFromURL()` instead.
`boolean` | `isRequestedSessionIdFromURL()` Checks whether the requested session ID came in as part of the request URL.
`boolean` | `isRequestedSessionIdValid()` Checks whether the requested session ID is still valid.
`boolean` | `isUserInRole(java.lang.String role)` Returns a boolean indicating whether the authenticated user is included in the specified logical "role".

Methods inherited from interface javax.servlet.ServletRequest
`getAttribute, getAttributeNames, getCharacterEncoding, getContentLength, getContentType, getInputStream, getLocale, getLocales, getParameter, getParameterMap, getParameterNames, getParameterValues, getProtocol, getReader, getRealPath, getRemoteAddr, getRemoteHost, getRequestDispatcher, getScheme, getServerName, getServerPort, isSecure, removeAttribute, setAttribute, setCharacterEncoding`

Field Detail

### BASIC_AUTH

    public static final java.lang.String BASIC_AUTH

  String identifier for Basic authentication. Value "BASIC"

### FORM_AUTH

    public static final java.lang.String FORM_AUTH

  String identifier for Basic authentication. Value "FORM"

### CLIENT_CERT_AUTH

    public static final java.lang.String CLIENT_CERT_AUTH

  String identifier for Basic authentication. Value "CLIENT_CERT"

### DIGEST_AUTH

    public static final java.lang.String DIGEST_AUTH

  String identifier for Basic authentication. Value "DIGEST"

Method Detail

### getAuthType

    public java.lang.String getAuthType()

  Returns the name of the authentication scheme used to protect the servlet. All servlet containers support basic, form and client certificate authentication, and may additionally support digest authentication. If the servlet is not authenticated `null` is returned.

  Same as the value of the CGI variable AUTH_TYPE.

  Returns:
    one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) indicating the authentication scheme, or `null` if the request was not authenticated.

### getCookies

    public Cookie[] getCookies()

  Returns an array containing all of the `Cookie` objects the client sent with this request. This method returns `null` if no cookies were sent.
  Returns:
    an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getDateHeader

    public long getDateHeader(java.lang.String name)

  Returns the value of the specified request header as a `long` value that represents a `Date` object. Use this method with headers that contain dates, such as `If-Modified-Since`.

  The date is returned as the number of milliseconds since January 1, 1970 GMT. The header name is case insensitive.

  If the request did not have a header of the specified name, this method returns -1. If the header can't be converted to a date, the method throws an `IllegalArgumentException`.

  Parameters:
    `name` - a `String` specifying the name of the header
  Returns:
    a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the reqest
  Throws:
    `java.lang.IllegalArgumentException` - If the header value can't be converted to a date

### getHeader

    public java.lang.String getHeader(java.lang.String name)

  Returns the value of the specified request header as a `String`. If the request did not include a header of the specified name, this method returns `null`. The header name is case insensitive. You can use this method with any request header.
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### getHeaders

    public java.util.Enumeration getHeaders(java.lang.String name)

  Returns all the values of the specified request header as an `Enumeration` of `String` objects.

  Some headers, such as `Accept-Language` can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

  If the request did not include any headers of the specified name, this method returns an empty `Enumeration`. The header name is case insensitive. You can use this method with any request header.

  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getHeaderNames

    public java.util.Enumeration getHeaderNames()

  Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

  Some servlet containers do not allow do not allow servlets to access headers using this method, in which case this method returns `null`

  Returns:
    an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getIntHeader

    public int getIntHeader(java.lang.String name)

  Returns the value of the specified request header as an `int`. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an integer, this method throws a `NumberFormatException`.

  The header name is case insensitive.

  Parameters:
    `name` - a `String` specifying the name of a request header
  Returns:
    an integer expressing the value of the request header or -1 if the request doesn't have a header of this name
  Throws:
    `java.lang.NumberFormatException` - If the header value can't be converted to an `int`

### getMethod

    public java.lang.String getMethod()

  Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.
  Returns:
    a `String` specifying the name of the method with which this request was made

### getPathInfo

    public java.lang.String getPathInfo()

  Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string. This method returns `null` if there was no extra path information.

  Same as the value of the CGI variable PATH_INFO.

  Returns:
    a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPathTranslated

    public java.lang.String getPathTranslated()

  Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

  If the URL does not have any extra path information, this method returns `null`. The web container does not decode thins string.

  Returns:
    a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getContextPath

    public java.lang.String getContextPath()

  Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.
  Returns:
    a `String` specifying the portion of the request URI that indicates the context of the request

### getQueryString

    public java.lang.String getQueryString()

  Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.
  Returns:
    a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### getRemoteUser

    public java.lang.String getRemoteUser()

  Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.
  Returns:
    a `String` specifying the login of the user making this request, or `null`

  ### isUserInRole

      public boolean isUserInRole(java.lang.String role)

    Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns `false`.
    Parameters:
      `role` - a `String` specifying the name of the role
    Returns:
      a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

  ### getUserPrincipal

      public java.security.Principal getUserPrincipal()

    Returns a `java.security.Principal` object containing the name of the current authenticated user. If the user has not been authenticated, the method returns `null`.
    Returns:
      a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

  ### getRequestedSessionId

      public java.lang.String getRequestedSessionId()

    Returns the session ID specified by the client. This may not be the same as the ID of the actual session in use. For example, if the request specified an old (expired) session ID and the server has started a new session, this method gets a new session with a new ID. If the request did not specify a session ID, this method returns `null`.
    Returns:
      a `String` specifying the session ID, or `null` if the request did not specify a session ID
    See Also:
      `isRequestedSessionIdValid()`

  ### getRequestURI

      public java.lang.String getRequestURI()

    Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

    First line of HTTP request | Returned Value
    --- | ---
    POST /some/path.html HTTP/1.1 |  | /some/path.html
    GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
    HEAD /xyz?a=b HTTP/1.1 |  | /xyz

    To reconstruct an URL with a scheme and host, use `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`.

    Returns:
      a `String` containing the part of the URL from the protocol name up to the query string
    See Also:
      `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`

  ### getRequestURL

      public java.lang.StringBuffer getRequestURL()

    Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

    Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append query parameters.

    This method is useful for creating redirect messages and for reporting errors.

    Returns:
      a `StringBuffer` object containing the reconstructed URL

  ### getServletPath

      public java.lang.String getServletPath()

    Returns the part of this request's URL that calls the servlet. This includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.
    Returns:
      a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded.

  ### getSession

      public HttpSession getSession(boolean create)

    Returns the current `HttpSession` associated with this request or, if if there is no current session and `create` is true, returns a new session.

    If `create` is `false` and the request has no valid `HttpSession`, this method returns `null`.

    To make sure the session is properly maintained, you must call this method before the response is committed. If the container is using cookies to maintain session integrity and is asked to create a new session when the response is committed, an IllegalStateException is thrown.

    Parameters:
      ``true`` - to create a new session for this request if necessary; `false` to return `null` if there's no current session
    Returns:
      the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
    See Also:
      `getSession()`

  ### getSession

      public HttpSession getSession()

    Returns the current session associated with this request, or if the request does not have a session, creates one.
    Returns:
      the `HttpSession` associated with this request
    See Also:
      `getSession(boolean)`

  ### isRequestedSessionIdValid

      public boolean isRequestedSessionIdValid()

    Checks whether the requested session ID is still valid.
    Returns:
      `true` if this request has an id for a valid session in the current session context; `false` otherwise
    See Also:
      `getRequestedSessionId()`, `getSession(boolean)`, `HttpSessionContext`

  ### isRequestedSessionIdFromCookie

      public boolean isRequestedSessionIdFromCookie()

    Checks whether the requested session ID came in as a cookie.
    Returns:
      `true` if the session ID came in as a cookie; otherwise, `false`
    See Also:
      `getSession(boolean)`

  ### isRequestedSessionIdFromURL

      public boolean isRequestedSessionIdFromURL()

    Checks whether the requested session ID came in as part of the request URL.
    Returns:
      `true` if the session ID came in as part of a URL; otherwise, `false`
    See Also:
      `getSession(boolean)`

  ### isRequestedSessionIdFromUrl

      public boolean isRequestedSessionIdFromUrl()

    Deprecated. As of Version 2.1 of the Java Servlet API, use `isRequestedSessionIdFromURL()` instead.

  Overview | Package | Class | Use | Tree | Deprecated | Index | Help
  PREV CLASS NEXT CLASS | FRAMES NO FRAMES
  SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

  Copyright © 1999-2001 The Apache Software Foundation. All Rights Reserved.